library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;

entity top_level is

Port (led					: out std_logic_vector(3 downto 0);
		btn					: in std_logic_vector(1 downto 0);
		j1,j2,j3,j4,j7		: in std_logic_vector(17 downto 0);
		clk					: in std_logic);
end top_level;

architecture Behavioral of top_level is

signal count: 			std_logic_vector(26 downto 0);
signal i_o:				std_logic_vector(89 downto 0);
signal io_sum: 		std_logic_vector(6 downto 0);
signal pwm: 			std_logic_vector(7 downto 0);
signal btns,ok,fade:	std_logic;

begin
	
	process(clk)
	begin
		if clk'event and clk = '1' then
		if (btns='0')		then count <= count + '1';
		elsif (btns='1')	then count <= count - '1';
		end if;
		end if;
	end process;
	
process(btn)
begin
  if (btn(0) = '0') then
      btns <= '0';
  elsif (btn(1) = '0') then
		btns <= '1';
  end if;
end process;

i_o <= j1&j2&j3&j4&j7;

io_sum <= 
 ("000000"&i_o(	0	))
+("000000"&i_o(	1	))
+("000000"&i_o(	2	))
+("000000"&i_o(	3	))
+("000000"&i_o(	4	))
+("000000"&i_o(	5	))
+("000000"&i_o(	6	))
+("000000"&i_o(	7	))
+("000000"&i_o(	8	))
+("000000"&i_o(	9	))
+("000000"&i_o(	10	))
+("000000"&i_o(	11	))
+("000000"&i_o(	12	))
+("000000"&i_o(	13	))
+("000000"&i_o(	14	))
+("000000"&i_o(	15	))
+("000000"&i_o(	16	))
+("000000"&i_o(	17	))
+("000000"&i_o(	18	))
+("000000"&i_o(	19	))
+("000000"&i_o(	20	))
+("000000"&i_o(	21	))
+("000000"&i_o(	22	))
+("000000"&i_o(	23	))
+("000000"&i_o(	24	))
+("000000"&i_o(	25	))
+("000000"&i_o(	26	))
+("000000"&i_o(	27	))
+("000000"&i_o(	28	))
+("000000"&i_o(	29	))
+("000000"&i_o(	30	))
+("000000"&i_o(	31	))
+("000000"&i_o(	32	))
+("000000"&i_o(	33	))
+("000000"&i_o(	34	))
+("000000"&i_o(	35	))
+("000000"&i_o(	36	))
+("000000"&i_o(	37	))
+("000000"&i_o(	38	))
+("000000"&i_o(	39	))
+("000000"&i_o(	40	))
+("000000"&i_o(	41	))
+("000000"&i_o(	42	))
+("000000"&i_o(	43	))
+("000000"&i_o(	44	))
+("000000"&i_o(	45	))
+("000000"&i_o(	46	))
+("000000"&i_o(	47	))
+("000000"&i_o(	48	))
+("000000"&i_o(	49	))
+("000000"&i_o(	50	))
+("000000"&i_o(	51	))
+("000000"&i_o(	52	))
+("000000"&i_o(	53	))
+("000000"&i_o(	54	))
+("000000"&i_o(	55	))
+("000000"&i_o(	56	))
+("000000"&i_o(	57	))
+("000000"&i_o(	58	))
+("000000"&i_o(	59	))
+("000000"&i_o(	60	))
+("000000"&i_o(	61	))
+("000000"&i_o(	62	))
+("000000"&i_o(	63	))
+("000000"&i_o(	64	))
+("000000"&i_o(	65	))
+("000000"&i_o(	66	))
+("000000"&i_o(	67	))
+("000000"&i_o(	68	))
+("000000"&i_o(	69	))
+("000000"&i_o(	70	))
+("000000"&i_o(	71	))
+("000000"&i_o(	72	))
+("000000"&i_o(	73	))
+("000000"&i_o(	74	))
+("000000"&i_o(	75	))
+("000000"&i_o(	76	))
+("000000"&i_o(	77	))
+("000000"&i_o(	78	))
+("000000"&i_o(	79	))
+("000000"&i_o(	80	))
+("000000"&i_o(	81	))
+("000000"&i_o(	82	))
+("000000"&i_o(	83	))
+("000000"&i_o(	84	))
+("000000"&i_o(	85	))
+("000000"&i_o(	86	))
+("000000"&i_o(	87	))
+("000000"&i_o(	88	))
+("000000"&i_o(	89	));

ok <= '1' WHEN io_sum = "0000001" ELSE '0';

process(count,fade,pwm,ok)
begin
	if (ok='1') then led <= (others => '1');
else
	if (fade = '0') then
   case count(25 downto 24) is 
		when "00" => led <= "0001";
		when "01" => led <= "0010";
		when "10" => led <= "0100";
		when "11" => led <= "1000";
       when others => led <= "0000";
   end case;
	elsif (fade = '1') then
	   case count(26 downto 24) is 
		when "000" => led(0) <= pwm(0); led(1) <= pwm(0); led(2) <= pwm(0); led(3) <= pwm(0);
		when "001" => led(0) <= pwm(1); led(1) <= pwm(1); led(2) <= pwm(1); led(3) <= pwm(1);
		when "010" => led(0) <= pwm(2); led(1) <= pwm(2); led(2) <= pwm(2); led(3) <= pwm(2);
		when "011" => led(0) <= pwm(3); led(1) <= pwm(3); led(2) <= pwm(3); led(3) <= pwm(3);
		when "100" => led(0) <= pwm(4); led(1) <= pwm(4); led(2) <= pwm(4); led(3) <= pwm(4);
		when "101" => led(0) <= pwm(5); led(1) <= pwm(5); led(2) <= pwm(5); led(3) <= pwm(5);
		when "110" => led(0) <= pwm(6); led(1) <= pwm(6); led(2) <= pwm(6); led(3) <= pwm(6);
		when "111" => led(0) <= pwm(7); led(1) <= pwm(7); led(2) <= pwm(7); led(3) <= pwm(7);
       when others => led <= "0000";
	  end case;
	end if;
	end if;
end process;

fade <= '1' WHEN btn = "00" ELSE '0';

pwm(7) <= '1';
pwm(6) <= count(17) or count(16);
pwm(5) <= count(16);
pwm(4) <= count(16) and count (15);
pwm(3) <= count(18) and count (17) and count (16);
pwm(2) <= count(18) and count (17)and count (16)and count (15);
pwm(1) <= count(18) and count (17)and count (16)and count (15)and count (14) and count (13);
pwm(0) <= '0';

end Behavioral;